//Loader Script of modnum for scilab
//Generated by generate_loader.sce
//23-Jul-2009 A.Layec

//Redefine stacksize
sz=stacksize(); //default 5e6
while (sz(1)<50e6) then
  ierr=execstr('stacksize(sz(1)+5e6)','errcatch');
  if ierr<>0 then break, end
  sz=stacksize();
end
clear sz;
clear ierr;

//Define modnum root path
MODNUMSCI=get_absolute_file_path('loader.sce');
if part(MODNUMSCI,length(MODNUMSCI))=='/' then
   MODNUMSCI=part(MODNUMSCI,1:length(MODNUMSCI)-1);
end
//Search Scilab Version
getf(MODNUMSCI+'/macros/build_util/find_scilab_ver.sci');
[ok]=find_scilab_ver();
if ~ok then
  printf("modnum only work with ScicosLab\n");
  abort;
end
//Load modnum_build_util library
modnum_build_util=lib(MODNUMSCI+'/macros/build_util/');

//Load modnum_find_file library
modnum_find_file=lib(MODNUMSCI+'/macros/find_file/');

//Load modnum_misc library
modnum_misc=lib(MODNUMSCI+'/macros/misc/');

//Load modnum_pll library
modnum_pll=lib(MODNUMSCI+'/macros/pll/');

//Load modnum_signal library
modnum_signal=lib(MODNUMSCI+'/macros/signal/');

if ~MSDOS then
//Link libmodnum_lib library
if ~exists('Id_libmodnum_lib') then
  Id_libmodnum_lib=link(MODNUMSCI+"/../../src/libmodnum_lib.so");
end
else
//Link libmodnum_lib library
if ~exists('Id_libmodnum_lib') then
  Id_libmodnum_lib=link(MODNUMSCI+"/../../src/libmodnum_lib.dll");
end
end

if ~MSDOS then
//Link of interfaced modnum functions
modnum_sci_func=["autocorr";"awgn";"demodpsk";"demodqam";"despread";"downsmpl";"gengold";"genint";"genpn";"genrayl";"intsym";"modpsk";"modqam";"nfilter";"spread";"upsmpl";];
addinter(MODNUMSCI+"/gateway/libintmodnum_lib.so","intmodnum_lib",modnum_sci_func);

else
modnum_sci_func=["autocorr";"awgn";"demodpsk";"demodqam";"despread";"downsmpl";"gengold";"genint";"genpn";"genrayl";"intsym";"modpsk";"modqam";"nfilter";"spread";"upsmpl";];
addinter(MODNUMSCI+"/gateway/libintmodnum_lib.dll","intmodnum_lib",modnum_sci_func);
end

//Add demos and man pages
if fileinfo(MODNUMSCI+'/help')<>[] then
  //find the LANGUAGE
  if ~exists('LANGUAGE') then
    global LANGUAGE;lang=LANGUAGE;clear LANGUAGE;
  else
    lang=LANGUAGE;
  end
  if lang<>'fr'&lang<>'eng' then
    printf("Documentation: Unsupported language %s, switch to eng.\n",lang);
    lang='eng';
  end
  //Add modnum help chapter
  myhelps=[MODNUMSCI+'/help/'+lang+'/htm',               "Modnum communication toolbox (Scilab)"];
  add_help_chapter(myhelps(1,2),myhelps(1,1))
  //Add modnum demo
  prot=funcprot(); //to disable warning
  funcprot(0);
  add_demo('Modnum (Scilab)',               MODNUMSCI+'/demos/modnumsci.dem');
  funcprot(prot)
  clear prot
  clear lang
end
